/*******************************************************************************/
/****                          FINANCEIRO                                   ****/
/*******************************************************************************/

/* Tabela CONTARECEBER: Conta a Receber */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CONTARECEBER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Conta a Receber,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_CTRECEBER
AFTER DELETE OR INSERT OR UPDATE
ON CONTARECEBER FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
BEGIN
   V_TIPO         := '0';
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      IF (NOT (:OLD.CDTPCTRECEB) IS NULL  AND
          NOT (:OLD.CDEMPRESA)   IS NULL) OR
         (NOT (:OLD.NRLANBOLREC) IS NULL) THEN
         V_TIPO := '3';
         V_DESC := 'Venc. '     || TO_CHAR(:OLD.DTATUAVENREC, 'DD/MM/YYYY')     ||
                   ' VrLiq '    || TO_CHAR(:OLD.VRATUAREC)                      ||
                   ' Status '   || :OLD.IDSTATREC                               ||
                   ' TpConta '  || :OLD.CDTPCTRECEB                             ||
                   ' Empresa '  || :OLD.CDEMPRESA                               ||
                   ' Parc '     || :OLD.NRSEQVENREC || '/' || :OLD.NRPARCELAREC ||
                   ' VencOrig ' || TO_CHAR(:OLD.DTORIGVENREC, 'DD/MM/YYYY')     ||
                   ' VrOrig '   || TO_CHAR(:OLD.VRORIGREC)                      ||
                   ' FiliDupl ' || :OLD.CDFILIALDUP                             ||
                   ' NrDupl '   || :OLD.NRLANCTODUP                             ||
                   ' Classf '   || :OLD.CDCLASSFINA                             ||
                   ' FiliFx '   || :OLD.CDFIMOVFLREC                            ||
                   ' DtFx'      || TO_CHAR(:OLD.DTMOVFLUXO, 'DD/MM/YYYY')       ||
                   ' IdTpFx '   || :OLD.IDMOVFLUXO;

         V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANCTONF||:OLD.NRSEQVENREC||:OLD.NRPARCELAREC|| '/' ||:OLD.CDFILIBOLREC||:OLD.NRLANBOLREC;
         V_CDFILLOGOPER := :OLD.CDFILIAL;
      END IF;
   ELSE
      IF (NOT (:NEW.CDTPCTRECEB) IS NULL  AND
          NOT (:NEW.CDEMPRESA)   IS NULL) OR
         (NOT (:NEW.NRLANBOLREC) IS NULL) THEN

         IF UPDATING THEN
            V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANCTONF||:OLD.NRSEQVENREC||:OLD.NRPARCELAREC|| '/' ||:NEW.CDFILIBOLREC||:NEW.NRLANBOLREC;
            V_CDFILLOGOPER := :OLD.CDFILIAL;

            IF (:NEW.DTATUAVENREC <> :OLD.DTATUAVENREC) OR
               (:NEW.VRATUAREC    <> :OLD.VRATUAREC)    OR
               (:NEW.IDSTATREC    <> :OLD.IDSTATREC)    OR
               (:NEW.CDTPCTRECEB  <> :OLD.CDTPCTRECEB)  OR
               (:NEW.CDEMPRESA    <> :OLD.CDEMPRESA)    OR
               (:NEW.CDFILIBOLREC <> :OLD.CDFILIBOLREC) OR
               (:NEW.NRLANBOLREC  <> :OLD.NRLANBOLREC)  OR
               (:NEW.CDFILIAL     <> :OLD.CDFILIAL)     OR
               (:NEW.NRLANCTONF   <> :OLD.NRLANCTONF)   OR
               (:NEW.CDFILIALDUP  <> :OLD.CDFILIALDUP)  OR
               (:NEW.NRLANCTODUP  <> :OLD.NRLANCTODUP)  OR
               (:NEW.NRSEQVENREC  <> :OLD.NRSEQVENREC)  OR
               (:NEW.NRPARCELAREC <> :OLD.NRPARCELAREC) THEN
               V_TIPO := '2';
            END IF;

         ELSE
            V_TIPO         := '1';
            V_ITPESQ       := :NEW.CDFILIAL||:NEW.NRLANCTONF||:NEW.NRSEQVENREC||:NEW.NRPARCELAREC|| '/' ||:NEW.CDFILIBOLREC||:NEW.NRLANBOLREC;
            V_CDFILLOGOPER := :NEW.CDFILIAL;
         END IF;

         V_DESC := 'Venc. '     || TO_CHAR(:NEW.DTATUAVENREC, 'DD/MM/YYYY')     ||
                   ' VrLiq '    || TO_CHAR(:NEW.VRATUAREC)                      ||
                   ' Status '   || :NEW.IDSTATREC                               ||
                   ' TpConta '  || :NEW.CDTPCTRECEB                             ||
                   ' Empresa '  || :NEW.CDEMPRESA                               ||
                   ' Parc '     || :NEW.NRSEQVENREC || '/' || :NEW.NRPARCELAREC ||
                   ' VencOrig ' || TO_CHAR(:NEW.DTORIGVENREC, 'DD/MM/YYYY')     ||
                   ' VrOrig '   || TO_CHAR(:NEW.VRORIGREC)                      ||
                   ' FiliDupl ' || :NEW.CDFILIALDUP                             ||
                   ' NrDupl '   || :NEW.NRLANCTODUP                             ||
                   ' Classf '   || :NEW.CDCLASSFINA                             ||
                   ' FiliFx '   || :NEW.CDFIMOVFLREC                            ||
                   ' DtFx'      || TO_CHAR(:NEW.DTMOVFLUXO, 'DD/MM/YYYY')       ||
                   ' IdTpFx '   || :NEW.IDMOVFLUXO;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         WEBTUNNING(V_DSREMOTEADDR,
                    V_DSREMOTEHOST,
                    V_DSSERVERRDM,
                    V_DSSERVMETHOD,
                    V_DSREMOTEOPER);

         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER,
                DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CONTARECEBER', V_DTOPER, V_USUARIO,
                V_TIPO,         V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_CTRECEBER','5.20.000'); END;
/
